


SharperTurning = {};
local IsDebugEnabled = false;

--------------------------------------------------
-- Modified Values for Tractor and Harvester
--------------------------------------------------
SharperTurning.TrailerAttacher = {
	['data/vehicles/steerable/buehrer/buehrer6135A.xml'] 			= {10, 70, 70}, --ok
	['data/vehicles/steerable/deutz/deutzAgroStar661.xml'] 			= {10, 60, 70}, --ok
	['data/vehicles/steerable/deutz/deutzFahr7250.xml'] 			= {10, 62, 70}, --ok
	['data/vehicles/steerable/steyr/steyrMulti4115.xml'] 			= {10, 65, 70}, --ok
	['data/vehicles/steerable/steyr/steyrMulti4115Forestry.xml'] 	= {10, 65, 70}, --ok
	['data/vehicles/steerable/caseIH/caseIHPuma160.xml'] 			= {10, 50, 70}, --naja
	['data/vehicles/steerable/huerlimann/huerlimannH488.xml'] 		= {10, 70, 70}, --ok
	['data/vehicles/steerable/huerlimann/huerlimannXM4Ti.xml'] 		= {10, 70, 70}, --ok
	['data/vehicles/steerable/lamborghini/Mach230VRT.xml'] 			= {10, 64, 70}, --ok
	['data/vehicles/steerable/lindner/lindnerGeotrac94.xml'] 		= {10, 60, 70}, --ok
	['data/vehicles/steerable/newHolland/newHollandT475.xml'] 		= {10, 67, 80}, --ok
	['data/vehicles/steerable/newHolland/newHollandT6160.xml'] 		= {10, 70, 70}, --ok
	['data/vehicles/steerable/newHolland/newHollandT8320.xml'] 		= {10, 70, 70}, --ok
	['data/vehicles/steerable/newHolland/newHollandT8435.xml'] 		= {10, 70, 70},
	['data/vehicles/steerable/newHolland/newHollandT9560.xml'] 		= {20, 70, 70}, --ok
	['data/vehicles/steerable/same/sameFortis190.xml'] 				= {10, 60, 70}, --ok
	['data/vehicles/steerable/ursus/ursus15014.xml'] 				= {10, 60, 70}, --ok
};

SharperTurning.TrailerLowAttacher = {
	['data/vehicles/steerable/buehrer/buehrer6135A.xml'] 			= {10, 77, 80}, --ok
	['data/vehicles/steerable/deutz/deutzAgroStar661.xml'] 			= {10, 60, 70}, --ok
	['data/vehicles/steerable/deutz/deutzFahr7250.xml'] 			= {10, 67, 70}, --ok
	['data/vehicles/steerable/steyr/steyrMulti4115.xml'] 			= {10, 61, 70}, --ok
	['data/vehicles/steerable/steyr/steyrMulti4115Forestry.xml'] 	= {10, 61, 70}, --ok
	['data/vehicles/steerable/caseIH/caseIH9230Crawler.xml'] 		= {10, 80, 70},
	['data/vehicles/steerable/caseIH/caseIHMagnum380.xml'] 			= {10, 80, 70}, --ok
	['data/vehicles/steerable/caseIH/caseIHPuma160.xml'] 			= {10, 64, 70}, --ok
	['data/vehicles/steerable/caseIH/caseIHQuadtrac620.xml'] 		= {10, 85, 70}, --ok
	['data/vehicles/steerable/huerlimann/huerlimannH488.xml'] 		= {10, 63, 70}, --ok
	['data/vehicles/steerable/huerlimann/huerlimannXM4Ti.xml'] 		= {10, 70, 70}, --ok
	['data/vehicles/steerable/lamborghini/Mach230VRT.xml'] 			= {10, 67, 70}, --ok
	['data/vehicles/steerable/lindner/lindnerGeotrac94.xml'] 		= {10, 70, 70}, --ok
	['data/vehicles/steerable/newHolland/newHollandCR1090.xml'] 	= {10, 80, 50},
	['data/vehicles/steerable/newHolland/newHollandT475.xml'] 		= {10, 72, 70}, --ok
	['data/vehicles/steerable/newHolland/newHollandT6160.xml'] 		= {10, 90, 70}, --ok
	['data/vehicles/steerable/newHolland/newHollandT8320.xml'] 		= {10, 85, 70}, --ok
	['data/vehicles/steerable/newHolland/newHollandT8435.xml'] 		= {10, 75, 70}, --ok
	['data/vehicles/steerable/newHolland/newHollandT9560.xml'] 		= {10, 85, 70}, --ok
	['data/vehicles/steerable/newHolland/newHollandTC590.xml'] 		= {10, 80, 50},
	['data/vehicles/steerable/same/sameFortis190.xml'] 				= {10, 62, 70}, --ok
	['data/vehicles/steerable/sampoRosenlew/sampoRosenlewC6.xml'] 	= {10, 80, 50},
	['data/vehicles/steerable/ursus/ursus15014.xml'] 				= {10, 74, 80}, --ok
};

--------------------------------------------------
-- Pre Initialize
--------------------------------------------------
function SharperTurning.prerequisitesPresent(specializations)
	return true;
end;

--------------------------------------------------
-- Load Script
--------------------------------------------------
function SharperTurning:load(xmlFile)	
	--------------------------------------------------
	-- Load and Prepare Script
	--------------------------------------------------
	self.SharperTurning = {};
	local trailerX, trailerY, trailerZ 				= 0;
	local trailerLowX, trailerLowY, trailerLowZ 	= 0;
	local trailerModificationsFound 				= false;
	local trailerLowModificationsFound 				= false;
	
	--------------------------------------------------
	-- Check and Load Modified MaxRotLimit Values
	--------------------------------------------------
	if SharperTurning.TrailerAttacher[self.configFileName] then
		trailerX, trailerY, trailerZ = unpack(SharperTurning.TrailerAttacher[self.configFileName]);		
		trailerModificationsFound = true;	
	end;
	
	if SharperTurning.TrailerLowAttacher[self.configFileName] then
		trailerLowX, trailerLowY, trailerLowZ = unpack(SharperTurning.TrailerLowAttacher[self.configFileName]);		
		trailerLowModificationsFound = true;	
	end;
	
	--------------------------------------------------
	-- Modify MaxRotLimit
	--------------------------------------------------
	
	if trailerModificationsFound or trailerLowModificationsFound then		
		for _, jointDesc in pairs(self.attacherJoints) do
			if jointDesc.maxRotLimit ~= nil and jointDesc.jointType == Vehicle.JOINTTYPE_TRAILERLOW then
				if trailerLowModificationsFound == true then
					if IsDebugEnabled then print(('SharperTurning DebugMessage: maxRotLimit festgelegt auf ||x = %.9f, y = %.9f, z = %.9f|| bei %q (original TrailerLow)' ):format(jointDesc.maxRotLimit[1], jointDesc.maxRotLimit[2], jointDesc.maxRotLimit[3], self.configFileName)); end;				
					jointDesc.maxRotLimit[1] = math.rad(math.abs(trailerLowX));
					jointDesc.maxRotLimit[2] = math.rad(math.abs(trailerLowY));
					jointDesc.maxRotLimit[3] = math.rad(math.abs(trailerLowZ));
					if IsDebugEnabled then print(('SharperTurning DebugMessage: maxRotLimit festgelegt auf ||x = %.9f, y = %.9f, z = %.9f|| bei %q (verbessert TrailerLow)'):format(jointDesc.maxRotLimit[1], jointDesc.maxRotLimit[2], jointDesc.maxRotLimit[3], self.configFileName)); end;
				end;
			end;
			if jointDesc.maxRotLimit ~= nil and jointDesc.jointType == Vehicle.JOINTTYPE_TRAILER then
				if trailerModificationsFound == true then
					if IsDebugEnabled then print(('SharperTurning DebugMessage: maxRotLimit festgelegt auf ||x = %.9f, y = %.9f, z = %.9f|| bei %q (original Trailer)'):format(jointDesc.maxRotLimit[1], jointDesc.maxRotLimit[2], jointDesc.maxRotLimit[3], self.configFileName)); end;	
					jointDesc.maxRotLimit[1] = math.rad(math.abs(trailerX));
					jointDesc.maxRotLimit[2] = math.rad(math.abs(trailerY));
					jointDesc.maxRotLimit[3] = math.rad(math.abs(trailerZ));
					if IsDebugEnabled then print(('SharperTurning DebugMessage: maxRotLimit festgelegt auf ||x = %.9f, y = %.9f, z = %.9f|| bei %q (verbessert Trailer)'):format(jointDesc.maxRotLimit[1], jointDesc.maxRotLimit[2], jointDesc.maxRotLimit[3], self.configFileName)); end;
				end;
			end;
		end;
	end;
end;

function SharperTurning:delete() end;
function SharperTurning:mouseEvent(posX, posY, isDown, isUp, button) end;
function SharperTurning:keyEvent(unicode, sym, modifier, isDown) end;
function SharperTurning:readStream(streamId, connection) end;
function SharperTurning:writeStream(streamId, connection) end;
function SharperTurning:update(dt) end;
function SharperTurning:updateTick(dt) end;
function SharperTurning:draw() end;
