SpecializationUtil.registerSpecialization("SharperTurning", "SharperTurning", g_currentModDirectory.."SharperTurning.lua")

SharperTurning_Register = {};

function SharperTurning_Register:loadMap(name)
	local hasSteerableSpeci = false;
	--local hasFillableSpeci = false;
	
	if self.firstRun == nil then
		self.firstRun = false;
		print("--- loading SharperTurning Version 1.0 by mjk ---")
		
		for k, v in pairs(VehicleTypeUtil.vehicleTypes) do
			if v ~= nil then
				local allowInsertion = true;
			
				for i = 1, table.maxn(v.specializations) do			
					local vs = v.specializations[i];
					--Needed Specialization 1
					if vs == SpecializationUtil.getSpecialization("steerable") then
						hasSteerableSpeci = true;
					end;					
					--Not allowed Specializations
					if vs == SpecializationUtil.getSpecialization("selfPropelledMixerWagon") or
					   vs == SpecializationUtil.getSpecialization("mixerWagon") or
					   vs == SpecializationUtil.getSpecialization("strawBlower") or
					   vs == SpecializationUtil.getSpecialization("mower") then
						--allowInsertion = false;
					end;
				end;
				
				--Add Specialization
				if hasSteerableSpeci then
					local v_name_string = v.name 
					local point_location = string.find(v_name_string, ".", nil, true)
					if point_location ~= nil then
						local _name = string.sub(v_name_string, 1, point_location-1);
						if rawget(SpecializationUtil.specializations, string.format("%s.SharperTurning", _name)) ~= nil then
							allowInsertion = false;								
						end;							
					end;
					--Add Specialization to the Mod
					table.insert(v.specializations, SpecializationUtil.getSpecialization("SharperTurning"));
					--print("  SharperTurning was inserted on " .. k);			
				end;
			end;
			hasSteerableSpeci = false;
			
		end;			
	end;
end;

function SharperTurning_Register:deleteMap()
  
end;

function SharperTurning_Register:keyEvent(unicode, sym, modifier, isDown)

end;

function SharperTurning_Register:mouseEvent(posX, posY, isDown, isUp, button)

end;

function SharperTurning_Register:update(dt)
	
end;

function SharperTurning_Register:draw()
  
end;

addModEventListener(SharperTurning_Register);